using Indotalent.ConfigBackEnd.Interfaces;
using Indotalent.ConfigFrontEnd.Common;
using Indotalent.Features.Profile.Password.Cqrs;
using Indotalent.Infrastructure.Authentication.Identity;
using Indotalent.Shared.Models;
using Microsoft.AspNetCore.Components;
using MudBlazor;
using RestSharp;

namespace Indotalent.Features.Profile.Password;

public class PasswordService : BaseService
{
    private readonly RestClient _client;

    public PasswordService(IHttpClientFactory clientFactory, NavigationManager nav, ISnackbar snackbar, ICurrentUserService currentUserService, TokenProvider tokenProvider)
            : base(clientFactory, nav, snackbar, currentUserService, tokenProvider)
    {
        _client = new RestClient(nav.BaseUri);
    }

    public async Task<ApiResponse<UpdatePasswordResponse>?> UpdatePasswordAsync(UpdatePasswordRequest data)
    {
        var request = new RestRequest("api/profile-password/update", Method.Post);
        request.AddJsonBody(data);
        return await ExecuteWithResponseAsync<UpdatePasswordResponse>(_client, request);
    }
}